searchNodes=[{"doc":"The Contexted.CRUD module generates common CRUD (Create, Read, Update, Delete) functions for a context, similar to what mix phx gen context task generates. Options :repo - The Ecto repository module used for database operations (required) :schema - The Ecto schema module representing the resource that these CRUD operations will be generated for (required) :exclude - A list of atoms representing the functions to be excluded from generation (optional) :plural_resource_name - A custom plural version of the resource name to be used in function names (optional). If not provided, singular version with 's' ending will be used to generate list function Usage defmodule MyApp.Accounts do use Contexted.CRUD , repo : MyApp.Repo , schema : MyApp.Accounts.User , exclude : [ :delete ] , plural_resource_name : &quot;users&quot; end This sample usage will generate all CRUD functions for MyApp.Accounts.User resource, excluding delete_user/1 . Generated Functions The following functions are generated by default. Any of them can be excluded by adding their correspoding atom to the :exclude option. list_{plural resource name} - Lists all resources in the schema. get_{resource name} - Retrieves a resource by its ID. Returns nil if not found. get_{resource name}! - Retrieves a resource by its ID. Raises an error if not found. create_{resource name} - Creates a new resource with the provided attributes. Returns an :ok tuple with the resource or an :error tuple with changeset. create_{resource name}! - Creates a new resource with the provided attributes. Raises an error if creation fails. update_{resource name} - Updates an existing resource with the provided attributes. Returns an :ok tuple with the resource or an :error tuple with changeset. update_{resource name}! - Updates an existing resource with the provided attributes. Raises an error if update fails. delete_{resource name} - Deletes an existing resource. Returns an :ok tuple with the resource or an :error tuple with changeset. delete_{resource name}! - Deletes an existing resource. Raises an error if delete fails. change_{resource name} - Returns changeset for given resource. {resource name} and {plural resource name} will be replaced by the singular and plural forms of the resource name.","ref":"Contexted.CRUD.html","title":"Contexted.CRUD","type":"module"},{"doc":"The Contexted.Delegator module provides a macro to delegate all functions defined within a specific module. This module can be used to forward all function calls from one module to another without the need to write individual defdelegate statements for each function. Usage To use the delegate_all macro, simply include it in your module and pass the target module as an argument: defmodule MyContextModule do import Contexted.Delegator delegate_all MyTargetSubcontextModule end All public functions defined in MyTargetSubcontextModule will now be accessible within MyContextModule . Note: This macro should be used with caution, as it may lead to unexpected behaviors if two modules with overlapping function names are delegated. Additional configuration The Contexted.Delegator module can be used without Mix.Tasks.Compile.Contexted as one of the compilers. However, if you wish to enable automatic @doc and @spec generation for delegated functions, you will need to set the following config: config :contexted , enable_recompilation : true","ref":"Contexted.Delegator.html","title":"Contexted.Delegator","type":"module"},{"doc":"Delegates all public functions of the given module. Examples defmodule MyContextModule do import Contexted.Delegator delegate_all MyTargetSubcontextModule end All public functions defined in MyTargetSubcontextModule will now be accessible within MyContextModule .","ref":"Contexted.Delegator.html#delegate_all/1","title":"Contexted.Delegator.delegate_all/1","type":"macro"},{"doc":"The Contexted.ModuleAnalyzer defines utils functions that analyze and extract information from other modules.","ref":"Contexted.ModuleAnalyzer.html","title":"Contexted.ModuleAnalyzer","type":"module"},{"doc":"Generates a list of unique argument names based on the given arity.","ref":"Contexted.ModuleAnalyzer.html#generate_random_function_arguments/1","title":"Contexted.ModuleAnalyzer.generate_random_function_arguments/1","type":"function"},{"doc":"Finds and returns the @doc definition in string format for the specified function name and arity. Returns nil if the function is not found in the function docs.","ref":"Contexted.ModuleAnalyzer.html#get_function_doc/3","title":"Contexted.ModuleAnalyzer.get_function_doc/3","type":"function"},{"doc":"Finds and returns the @spec definition in string format for the specified function name and arity. Returns nil if the function is not found in the specs.","ref":"Contexted.ModuleAnalyzer.html#get_function_spec/3","title":"Contexted.ModuleAnalyzer.get_function_spec/3","type":"function"},{"doc":"Fetches the @doc definitions for all functions within the given module.","ref":"Contexted.ModuleAnalyzer.html#get_functions_docs/1","title":"Contexted.ModuleAnalyzer.get_functions_docs/1","type":"function"},{"doc":"Fetches the @spec definitions for all functions within the given module.","ref":"Contexted.ModuleAnalyzer.html#get_functions_specs/1","title":"Contexted.ModuleAnalyzer.get_functions_specs/1","type":"function"},{"doc":"The Contexted.Tracer module provides a set of functions to trace and enforce separation between specific modules, known as &quot;contexts&quot;. This is useful when you want to ensure that certain modules do not reference each other directly within your application.","ref":"Contexted.Tracer.html","title":"Contexted.Tracer","type":"module"},{"doc":"To support automatic docs and specs generation in delegated functions inside contexts, all of the modules have to be compiled first. Because of that, we need to run this operation in after compiler callback in two steps: Remove all contexts beam files. Generate contexts beam files again. This is an opt-in step, so in order to enable it, you will have to set this config: config :contexted , enable_recompilation : true","ref":"Contexted.Tracer.html#after_compiler/1","title":"Contexted.Tracer.after_compiler/1","type":"function"},{"doc":"Trace events are emitted during compilation. trace function verifies if the provided event contains cross-references between two contexts. If so, raises an error with an appropriate message.","ref":"Contexted.Tracer.html#trace/2","title":"Contexted.Tracer.trace/2","type":"function"},{"doc":"The Contexted.Utils defines utils functions for other modules.","ref":"Contexted.Utils.html","title":"Contexted.Utils","type":"module"},{"doc":"Returns contexts option value from contexted config or [] if it's not set.","ref":"Contexted.Utils.html#get_config_contexts/0","title":"Contexted.Utils.get_config_contexts/0","type":"function"},{"doc":"Returns exclude_paths option value from contexted config or [] if it's not set.","ref":"Contexted.Utils.html#get_config_exclude_paths/0","title":"Contexted.Utils.get_config_exclude_paths/0","type":"function"},{"doc":"Checks is enable_recompilation option is set.","ref":"Contexted.Utils.html#recompilation_enabled?/0","title":"Contexted.Utils.recompilation_enabled?/0","type":"function"},{"doc":"A custom Elixir compiler task that checks for cross-references between specific modules, known as &quot;contexts&quot;.","ref":"Mix.Tasks.Compile.Contexted.html","title":"Mix.Tasks.Compile.Contexted","type":"task"},{"doc":"Sets the custom compiler tracer to the Contexted.Tracer module.","ref":"Mix.Tasks.Compile.Contexted.html#run/1","title":"Mix.Tasks.Compile.Contexted.run/1","type":"function"}]